<?php

class view_node_filter_views_handlers_year_dropdown extends views_handler_filter {

 	function exposed_form(&$form, &$form_state) {
		$form['custom_filter'] = array(
			'#type' => 'select',
			'#title'  => null,
			'#options'  => array(
				"all" 		=> "--All--",
				"this_year" 		=> "This Year",
				"last_year" 		=> "Last Year",
				"previous_years" 	=> "All Previous Years"
			)
		);
	}

	function admin_summary() {
		return t('exposed');
	}

	// You need to set this to return TRUE so that query() gets called
	function accept_exposed_input($input) {
		return TRUE;
	}

	function query() {
	    $input = $this->view->get_exposed_input();

	    if ( isset($input['custom_filter']) ) {

	    	$value = $input['custom_filter'];

	    	switch($value) {
	    		case "this_year":
	    			$timestamp = mktime(0,0,0,1,1,date("Y"));

				    $this
				    	->query
				    	->add_where($this->options['group'], "node.created",  $timestamp, ">");
	    			break;

    			case "last_year":
	    			$start_timestamp 	= mktime(0,0,0,1,1,date("Y")-1);
	    			$end_timestamp 		= mktime(0,0,0,1,1,date("Y"));

				    $this
				    	->query
				    	->add_where($this->options['group'], "node.created",  $start_timestamp, ">");

				    $this
				    	->query
				    	->add_where($this->options['group'], "node.created",  $end_timestamp, "<");
    				break;

    			case "previous_years":
    				$timestamp = mktime(0,0,0,1,1,date("Y")-1);

				    $this
				    	->query
				    	->add_where($this->options['group'], "node.created",  $timestamp, "<");
    				break;

	    		default:
	    			break;
	    	}
	    }
	    else {
			$timestamp = mktime(0,0,0,1,1,date("Y"));
			
		    $this
		    	->query
		    	->add_where($this->options['group'], "node.created",  $timestamp, ">");
	    }
	}

} // end @class